
#ifndef __ADAPT_H
#define __ADAPT_H

#include "ipp.h"

#define CHANGE_INITIAL	2  
#define CHANGE_GOAL     3  
#define TIMEOUT         4
#define PARTIAL_TIMEOUT 5

#define CUT_OFF 2

#define SEARCH 1
#define OPTIMIZE 2

#define MAX_SIZE 3
#define STEP     2

// these are for windows expansion (alterna)

#define FWD     1
#define BACK    2

// these are for sub-goal heuristics

#define SIMPLE        0
#define CAUSAL_LINKS  1


int backtrack, tot_backtrack;
int *backtrack_list;
int cut_off;
int iniz_step_cut, step_cut;

struct tms start_time, search_start;
float build_ad_time, fixpoint_time, gam_time;


struct ADAPT
{
   int plan_length;  
   int sub_plan_length;
   int best_plan_length;
   int task_type;
   int change;  
   int step;
   int timeout;
   int partial_timeout;
   int num_inc;  
   int num_actions;
   int best_num_actions;

   int goal_heuristics;
   int action_remotion;
   int goal_agenda;

   int alterna;
   int iteraz;
   int try;
  /* define the type of levels that has been considered in the optimization */
} adapt;


/* in file adapt.c */

BOOLEAN adapt_plan(int *curr_init_time_pointer);
int resize_plan(char* fact_file_name);

BOOLEAN find_act_vect(char* name, int level);
void insert_act_vect(char* name, int level);
void free_act_vect(int level);
void up_act_vect(int level);
void down_act_vect(int level);

void de_alloc(int max_time);
void free_table(hashtable *t, int max_size);
void free_edge_list(edge_list e);
void free_cond_edge_list(cond_edge_list ce);
void free_delete_list(delete_list de);
void free_vertex(vertex_list v);

int load_plan(char *file_plan);
void store_adapted_plan(int levels, char* fact_file_name, double time);


/* in file main.c */

void print_adj_report(float plan_time);


#endif __ADAPT_H
