
#include "ipp.h"
#include "adj.h"
#include "adapt.h"


/* from original ipp gam version */
void goal_agenda(goal_set_list start,goal_set_list end)
{

  goal_set_list curr;
  goal_list curr_inters;

  first_string = ( bit_string_list ) calloc( 1, sizeof( bit_string_list_elt ) );
  last_string = ( bit_string_list ) calloc( 1, sizeof( bit_string_list_elt ) );
  first_string->prev = NULL;
  first_string->next = last_string;
  last_string->prev = first_string;
  last_string->next = NULL;

  if ( oversize( start->right->set ) )
  {
     // have to split the goals
     compute_agenda( start, end );
     for ( curr = start->right; curr != end; curr = curr->right )
     {
	// see if one of the sets is still too large
	if ( do_inters && oversize( curr->set ) )
	{
	  // if so, do intermediate computation and insert in front of current set
	  curr_inters = intermediate( curr->set );
	  if ( curr_inters )
	    insert( curr->left, curr, curr_inters );

	}
     }
  }

  if ( linearize )
     for ( curr = start->right; curr != end; curr = curr->right )
        linearize_subplan( curr );

  printf( "\n" );

}

/* ADESSO CI SONO LE FUNZIONI CHE DAI CAUSAL LINKS DEL PIANO IN INGRESSO TROVANO LA CL_LIST */

/* sort_causal_link: funzione di alto livello che crea una nuova lista di insiemi di goal
		     che contiene l'ordinamento che e' rappresentato nei causal links
		     la lista viene restituita attraverso due puntatori globali
		     cl_start e cl_finish
		     il primo elemento e' cl_start->right
		     l'ultimo elemento e' cl_finish->left

   add_set_of_goals: questa funzione viene chiamata ogni volta che si trova che un causal link
                     porta ad un goal, e lo aggiunge alla lista
		     (nell'esempio sottostante aggiunge un elemento in orizzontale)
		     si preoccupa di scegliere il set adatto sul qualche chiamare la funzione
		     add_single_goal

   add_single_goal:  funzione di basso livello che alloca un nuovo goal nel sottoinsieme
                     di goals scelto dalla funzione add_set_of_goals
		     (nell'esempio sottostante aggiunge un elemento in verticale)

esempio:

cl_start <---> primo sottoinsieme (level 10) <----> secondo sottoinsieme (level 12) <----> cl_finish
                      |                                    |
		      |					   |
		      |					   |
		   primo goal				primo goal
		      |
		      |
		      |
		  secondo goal


quando devo aggiungere un nuovo goal, ci sono tre possibilita'
1) il nuovo valore e' uguale all'ultimo goal aggiunto (current_set)
2) il nuovo valore e' inferiore: in questo caso va aggiunto a sinistra
   se a sinistra trovo cl_start lo aggiunto subito
   altrimenti sposto il current_set e richiamo la funzione
3) analogamente per il caso superiore

N.B. nella gam originale i valori estremi si chiamano start e end

*/

void sort_causal_link(void)
{

  causal_link_list cl;
  current_set=NULL;

  cl_start=(goal_set_list)calloc(1,sizeof(goal_set_list_elt));
  CHECK_MEMORY(cl_start);
  cl_finish  =(goal_set_list)calloc(1,sizeof(goal_set_list_elt));
  CHECK_MEMORY(cl_finish);

  cl_start->left=NULL;
  cl_start->right=NULL;
  cl_finish->left=NULL;
  cl_finish->right=NULL;

   // faccio passare tutti i causal links
  for ( cl=causal_links ; cl!=NULL ; cl=cl->next )
     if (cl->from.time>=0 && strcmp(cl->to.action,GOAL_ACT)==SAME )
        add_set_of_goals(cl);

/*
  printf("\nGOAL ORDER EXTRACTED FROM INPUT PLAN \n\n");
  print_consistent_list(cl_start->right, cl_finish);
*/

  printf("\nGOAL REORDERING ...\n");
  compute_consistent_list();
  printf("\nNEW GOAL CONSISTENT LIST \n\n");
  print_consistent_list(cons_start->right, cons_finish);

/*
  printf("\n  * STORE_GOAL_FACTS: ");
  print_token_list(store_goal_facts,1);
  printf("\n\n  * CURRENT_GOAL_FACTS: ");
  print_token_list(current_goal_facts,1);
  printf("\n\n");
*/

  if (goal_removed)
  {
     compute_causal_links(current_goal_facts);
     compute_causal_links(store_goal_facts);
  }

}


// la funzione aggiunge un nuovo set di goals alla lista totale

void add_set_of_goals(causal_link_list cl)
{
  goal_list temp;

  // se e' il primo elemento lo aggiungo semplicemente
  if (current_set==NULL)
  {
     current_set = (goal_set_list)calloc(1,sizeof(goal_set_list_elt));
     CHECK_MEMORY(current_set);

     cl_start->right = current_set;
     current_set->left = cl_start;
     current_set->right = cl_finish;
     cl_finish->left = current_set;

     current_set->level = cl->from.time;
     current_set->is_a_new_set = FALSE;

     current_set->set = add_single_goal(cl);
  }

  // se l'elemento da aggiungere va messo prima dell'ultimo aggiunto
  else if (cl->from.time < current_set->level)
  {
     if (current_set->left != cl_start)
     {
        // se posso mi sposto a sinistra e richiamo la funzione
        current_set = current_set->left;
        add_set_of_goals(cl);
     }
     else
     {
        // altrimenti alloco un nuovo insieme
	current_set->left = (goal_set_list)calloc(1,sizeof(goal_set_list_elt));
	CHECK_MEMORY(current_set->left);

	current_set->left->right = current_set;
	current_set = current_set->left;
	current_set->left = cl_start;
	cl_start->right = current_set;
	current_set->level = cl->from.time;
	current_set->is_a_new_set = FALSE;

//   printf(" aggiunta a sinistra ");
        current_set->set = add_single_goal(cl);
    }
  }

  // se devo spostarmi a destra e a dx c' qualcosa diverso da cl_finish lo faccio
  else if (cl->from.time > current_set->level)

      if (current_set->right != cl_finish)
      {
         current_set = current_set->right;
         add_set_of_goals(cl);
      }
      else
      {
         current_set->right = (goal_set_list)calloc(1,sizeof(goal_set_list_elt));
	 CHECK_MEMORY(current_set->right);

	 current_set->right->left = current_set;
 	 current_set = current_set->right;
	 current_set->right = cl_finish;
	 cl_finish->left = current_set;
         current_set->level = cl->from.time;
	 current_set->is_a_new_set = FALSE;

//    printf(" aggiunta a destra ");
         current_set->set = add_single_goal(cl);
      }

      // a questo punto il valore del sottoinsieme  lo stesso
      else
      {
        temp = current_set->set;
        while (temp->next!=NULL)
           temp=temp->next;

//      printf(" aggiunta nello stesso set");
	temp->next = add_single_goal(cl);
      }
}



goal_list add_single_goal(causal_link_list cl)
{

   goal_list new_item, gam_goal;
   goal_set_list gam_set;

   new_item=(goal_list)calloc(1,sizeof(goal_list_elt));
   CHECK_MEMORY(new_item);

   //devo copiarci il nome del fatto
   //##NON VA BENE##DEVO COPIARCI IL GOAL INTERO
   //per adesso ci copio solo il nome!!!
   new_item->name = new_token( strlen(cl->fact) +1 );
   strcpy(new_item->name, cl->fact);
   new_item->next = NULL;

   //aggiornamento valore di num_unique
   for (gam_set=start->right; gam_set!=end; gam_set=gam_set->right)
     for (gam_goal=gam_set->set; gam_goal!=NULL; gam_goal=gam_goal->next)
     {
        if ( strcmp(cl->fact,gam_goal->name)==SAME )
        {
           new_item->num_unique = gam_goal->num_unique;
           return (new_item);
   	}
     }

   // se non ne trovo nessuno do' errore!
   printf("\n error in function add_single_goal with goal: %s\n",cl->fact);
   exit(1);
}

/* ORA CI SONO LE FUNZIONI CHE TROVANO LA LISTA CONSISTENTE DI GOAL A PARTIRE DALLA CL_LIST E DALLA GAM_LIST */

/* ora creo una nuova lista, detta lista consistente dei goal ho cons_start e cons_finish

   compute_consistent_list: funzione di alto livello che la calcola
   print_consistent_list: la visualizza
   cons_add_set_right: aggiunge un nuovo set di goal a destra di where
   cons_add_set_left:  lo aggiunge a sinistra
   cons_add_single_goal: aggiunge un singolo goal all'interno di where */

void print_consistent_list(goal_set_list initial_pointer, goal_set_list end_pointer)
{
  int t = 1;
  goal_set_list el;
  goal_list j;
  BOOLEAN first;

  for ( el = initial_pointer; el != end_pointer; el = el->right )
  {
     printf( ( el->is_a_new_set == TRUE ) ? "*" : " " );
     printf( " step %2d: (at level %2d)", t , el->level );
     first = TRUE;
     for ( j = el->set; j!=NULL; j = j->next )
     {
        if ( first )
        {
	   printf( " %s\n", j->name );
	   first = FALSE;
	}
        else
           printf("\t\t\t %s\n", j->name );
     }
     t++;
  }
}


// la funzione aggiunge un nuovo set di goals (what) alla destra di (where)
// mettendo what=NULL crea un sottoinsieme vuoto
goal_set_list cons_add_set_right(goal_set_list where, goal_set_list what, BOOLEAN is_new_set)
{
  goal_set_list new_set;

  new_set=(goal_set_list)calloc(1,sizeof(goal_set_list_elt));
  CHECK_MEMORY(new_set);

  if (what!=NULL)
     new_set->level = what->level;
  // poi devo copiare anche gli altri valori di what ###
  new_set->is_a_new_set = is_new_set;
  new_set->set = NULL;

  // se la lista e' vuota lo setto come primo elemento
  // se il corrente punta a NULL o a nessun elemento significativo la lista e' vuota
  if ( where==NULL || cons_start->right==cons_finish )
  {
     cons_start->right = new_set;
     new_set->left = cons_start;
     new_set->right = cons_finish;
     cons_finish->left = new_set;
  }
  else
  {
     new_set->left = where;
     new_set->right = where->right;
     where->right->left = new_set;
     where->right = new_set;
  }

  return (new_set);
}


// la funzione aggiunge un nuovo set di goals (what) a sinistra di (where)
goal_set_list cons_add_set_left(goal_set_list where, goal_set_list what, BOOLEAN is_new_set)
{
  goal_set_list new_set;

  new_set=(goal_set_list)calloc(1,sizeof(goal_set_list_elt));
  CHECK_MEMORY(new_set);

  if (what!=NULL)
     new_set->level=what->level;
  // poi devo copiare anche gli altri valori di what ###
  new_set->set=NULL;
  new_set->is_a_new_set=is_new_set;

  if ( where==NULL || cons_start->right==cons_finish )
  {
     cons_start->right = new_set;
     new_set->left = cons_start;
     new_set->right = cons_finish;
     cons_finish->left = new_set;
  }
  else
  {
     new_set->right = where;
     new_set->left = where->left;
     where->left->right = new_set;
     where->left = new_set;
  }

  return (new_set);
}


// aggiunge il singolo goal (what) nel sottoinsieme (where)
void cons_add_single_goal(goal_set_list where, goal_list what)
{
  goal_list new_goal,temp;

  new_goal=(goal_list)calloc(1,sizeof(goal_list_elt));
  CHECK_MEMORY(new_goal);

  new_goal->name = new_token( strlen(what->name) +1 );
  // ###### per ora ci copio solo il nome e num_unique
  strcpy(new_goal->name,what->name);
  new_goal->num_unique = what->num_unique;
  new_goal->next = NULL;

  // se il set e' vuoto
  if (where->set==NULL)
     where->set=new_goal;
  else
  {
     temp=where->set;
     while (temp->next!=NULL)
        temp=temp->next;
     temp->next=new_goal;
  }
}


// restituisce il set nel quale si trova un determinato goal
goal_set_list cons_search_single_goal(token goal_name)
{
  goal_set_list co_set;
  goal_list co_goal;

  for (co_set=cons_start->right; co_set!=cons_finish; co_set=co_set->right)
    for (co_goal=co_set->set; co_goal!=NULL; co_goal=co_goal->next)
       if (strcmp(co_goal->name,goal_name)==SAME)
          return (co_set);

  return (NULL); // il goal non esiste
}


// toglie un singolo goal nella cons list
void cons_remove_single_goal(goal_set_list where,token goal_name)
{
  goal_list temp,old;

  if ( goal_name==NULL || strlen(goal_name)<1 )
  {
     printf("\n error in function: cons_remove_single goal\n bad goal_name passed");
     exit(1);
  }

  if ( where==NULL || where->left==NULL || where->right==NULL || where->set==NULL )
  {
     printf("\n error in function: cons_remove_single goal\n bad location passed or empty");
     exit(1);
  }

  // gestisco a parte il caso di un solo elemento contenuto
  if (where->set->next==NULL)
  {
     free(where->set); // libero il goal e libero il set
     where->left->right = where->right;
     where->right->left = where->left;
     free(where);
     return;
  }

  // guardo se e' in prima posizione
  if (strcmp(where->set->name,goal_name)==SAME)
  {
     temp=where->set; // l'elemento da cancellare
     where->set=temp->next;
     free(temp);
     return;
  }

  // temp parte dal secondo elemento, old mi tiene traccia del precedente
  for ( temp = where->set->next , old = where->set; temp != NULL; temp = temp->next , old = old->next )
     if ( strcmp(temp->name,goal_name)==SAME )
     {
        old->next=temp->next;
        free(temp);
        return;
     }

  printf("\n error in function: cons_remove_single_goal\n goal %s not found in %d set", goal_name,where->level);
  exit(1);

}


void add_goal_in_set(goal_set_list set_list, goal_list gam_goal)
{
  goal_set_list temp_l;
  goal_list temp_g;

  BOOLEAN DIFFERENT_SET=TRUE;

  if (set_list->left->is_a_new_set==TRUE)
  {
     DIFFERENT_SET=FALSE;

     for (temp_g=set_list->left->set; temp_g!=NULL; temp_g=temp_g->next)
     // the goal must be ordered before another
        if ( GLOBAL_first_before_second[gam_goal->num_unique][temp_g->num_unique] )
        {
	   DIFFERENT_SET=TRUE;
	   break;
	}
  }

  if (DIFFERENT_SET)
  {
     temp_l=cons_add_set_left(set_list, NULL, TRUE);
     // ora devo aggiornare il valore del sottoinsieme ...
     temp_l->level=temp_l->left->level+1;
     if (act_vect[temp_l->level]!=NULL)
        up_act_vect(temp_l->left->level+1);
  }

  // e poi aggiungo il singolo goal
  cons_add_single_goal(set_list->left, gam_goal);
}



void compute_consistent_list(void)
{
  goal_set_list cl_set,cons_curr_set,gam_set,co_set,temp_l;
  goal_list cl_goal,co_goal,gam_goal;
  BOOLEAN FOUND;

  // inizializzazioni
  cons_start = (goal_set_list)calloc(1,sizeof(goal_set_list_elt));
  CHECK_MEMORY(cons_start);
  cons_finish  = (goal_set_list)calloc(1,sizeof(goal_set_list_elt));
  CHECK_MEMORY(cons_finish);
  cons_start->left = NULL;
  cons_finish->right = NULL;
  cons_start->right = cons_finish;
  cons_finish->left = cons_start;
  cons_start->is_a_new_set = FALSE;
  cons_finish->is_a_new_set = FALSE;
  cons_start->level = INVALID_VALUE;
  cons_finish->level = INVALID_VALUE; // metto tutto a -1
  cons_curr_set = cons_start;  // il puntatore corrente su start

  // all'inizio ci copio brutalmente l'ordinamento del piano in ingresso cl_start-->cl_finish
  for ( cl_set = cl_start->right; cl_set != cl_finish; cl_set = cl_set->right )
  {
     cons_curr_set=cons_add_set_right(cons_curr_set,cl_set,FALSE);

     for ( cl_goal = cl_set->set; cl_goal!=NULL; cl_goal = cl_goal->next )
        cons_add_single_goal(cons_curr_set,cl_goal);
  }

  // ora faccio passare ogni singolo goal della gam
  for (gam_set=start->right; gam_set!=end; gam_set=gam_set->right)
     for (gam_goal=gam_set->set; gam_goal!=NULL; gam_goal=gam_goal->next)
     {
//        printf("\n - current goal: %s",gam_goal->name);
        // lo confronto con ogni singolo goal della consistent list
	FOUND=FALSE;

        for ( co_set=cons_start->right; co_set!=cons_finish && !FOUND; co_set=co_set->right )
           for (co_goal=co_set->set; co_goal!=NULL; co_goal=co_goal->next)
           {
               if ( gam_goal->num_unique==co_goal->num_unique )
               {
             	  FOUND=TRUE;
      	          break;
	       }
               else if ( GLOBAL_first_before_second[gam_goal->num_unique][co_goal->num_unique] )
               {
                  FOUND=TRUE; // ho trovato che gam_goal deve precedere co_goal
                  goal_removed=FALSE;

        	  // ora devo cancellare gam_goal dalla lista consistente, se esiste
      	          temp_l = cons_search_single_goal(gam_goal->name);
      	
  	          if (temp_l!=NULL)
              	  {
   	             cons_remove_single_goal(temp_l,gam_goal->name);
    	             remove_token(current_goal_facts, gam_goal->name);
    	             goal_removed=TRUE;
	          }

	          printf("\n - Reordering goal '%s' before '%s'", gam_goal->name, co_goal->name);
	
	   	  add_goal_in_set(co_set, gam_goal);
                  break;
              }
           } // fine for

        if (!FOUND)
        {
	   if (cons_search_single_goal(gam_goal->name)!=NULL)
	   {
	      printf("\n error in function: compute_consistent_list with goal %s\n\n",gam_goal->name);
              exit ( 1 );
	   }

           printf("\n - No ordering for goal '%s'", gam_goal->name);
           add_goal_in_set(cons_finish, gam_goal);
        }

   } // fine for
   printf("\n");
}


void cons_update_level(int level_from, int increment)
{
  goal_set_list cons_set;

  for (cons_set=cons_start->right; cons_set!=cons_finish; cons_set=cons_set->right)
  {
     if (cons_set->level >= level_from)
        cons_set->level+=increment;
  }
}


/* la seguente funzione marca come gia' realizzato un goal in H(.) resettando il flag
   is_a_new_set che significa goal riordinato o nuovo. ho bisogno di resettarlo per non
   farlo piu' considerare come nuovo ma devo settarlo come REALIZED_GOAL in modo tale che appartenga ancora a G_ord.
   vengono resettati i flag  minori stretti di to.
   Attenzione: devo fare in modo che ne venga resettato solo uno alla volta. infatti il flag
   non e' proprieta' del singolo goal, ma del set di appartenenza (anche se nella maggior parte
   dei casi si ha che nel set c'e' un singolo goal). La singola finestra di pianificazione puo'
   realizzare un singolo set alla volta e l'inserimento di questo ulteriore controllo fa si che
   non sia possibile che un goal non realizzato venga settato come realizzato, qualora ci
   fossero dei problemi nella finestra di pianificazione.
*/

void cons_reset_goal_flag(int actual_time)
{
  goal_set_list cons_set;

  for (cons_set=cons_start->right; cons_set!=cons_finish; cons_set=cons_set->right)
  {
     if (cons_set->level < actual_time)
     {
        if (cons_set->is_a_new_set==TRUE)
        {
           cons_set->is_a_new_set = REALIZED_GOAL;
           break;
        }
     }
  }
}


/* dice se il goal  presente dall' istante "time" in poi */
BOOLEAN is_already_goal_at_time(token g_name, int time)
{
  goal_list co_goal;
  goal_set_list co_set;

  for ( co_set=cons_start->right ; co_set!=cons_finish ; co_set=co_set->right )
  {
     if ( co_set->level >= time )
     {
        for (co_goal=co_set->set; co_goal!=NULL; co_goal=co_goal->next)
           if (strcmp(co_goal->name,g_name)==SAME)
              return TRUE;
     }
  }

  return (FALSE);
}


/* ritorna il valore del timestep al quale e' presente un set con il flag di nuovo, zero altrimenti */
int first_reordered_goal(void)
{
  goal_set_list co_set;

  for ( co_set=cons_start->right ; co_set!=cons_finish ; co_set=co_set->right )
     if (co_set->is_a_new_set==TRUE)
        return (co_set->level);  // found it!

  return ( INVALID_VALUE ); // not reordered or new goal found
}
