%{

/* default yywrap function - always treat EOF as an EOF */
#define fctwrap() 1 

%}

%%
initial: return(INI);

goal: return(GOA);

[a-zA-Z0-9\-_]+/[ \t]*: {strcpy(yylval.string,yytext); return(TYPENAME);}

":"  return(':');

";"  return(';');

"("  return('(');

")"  return(')');

"=>" return(IMPL);

ALL { strcpy(yylval.string,yytext); return(QUANT);};

EX { strcpy(yylval.string,yytext); return(QUANT);};


not return(NOT);

"!" return(NOT);

^#(.)*\n   { lineno++; }

\?[a-zA-Z0-9\-\[\]]+ { 
                  strcpy(yylval.string,yytext); return(VARNAME); }

[a-zA-Z0-9\-]+/\(  { 
                  strcpy(yylval.string,yytext); return(PREDNAME); }

[,a-zA-Z0-9\-\[\]]+  { 
                  strcpy(yylval.string,yytext); return(CONSTNAME); }

\n    { lineno++; } 

.     ;

%%

